Option Explicit On
Option Strict On

Module mdlMain

    Sub Main()
        Dim locFourthClass As New FourthClass
        Dim locFirstClass As FirstClass = locFourthClass
        Dim locSecondClass As SecondClass = locFourthClass
        Dim locThirdClass As ThirdClass = locFourthClass

        Console.WriteLine(locFirstClass.AFunction_a)
        Console.WriteLine(locSecondClass.AFunction_a)
        Console.WriteLine(locThirdClass.AFunction_b)
        Console.WriteLine(locFourthClass.AFunction_b)
        Console.WriteLine()
        Console.WriteLine("Press key to exit!")
        Console.ReadKey()
    End Sub

End Module

Public Class FirstClass

    Public Overridable Function AFunction_a() As String
        Return "First class"
    End Function

End Class


Public Class SecondClass
    Inherits FirstClass

    Public Overrides Function AFunction_a() As String

        Return "Second class"

    End Function
End Class

Public Class ThirdClass
    Inherits SecondClass

    Public Overridable Function AFunction_b() As String

        Return "Third class"

    End Function

End Class


Public Class FourthClass
    Inherits ThirdClass

    Public Overrides Function AFunction_b() As String
        Return "Fourth class"
    End Function

End Class