Module NullableDemo

    Sub Main()
        Dim anObj As Object
        Dim aNullOfInt As Integer? = Nothing

        'Of course, there is only one usable instance, because
        'Integer? is a value type!

        Console.WriteLine("aNullOfInt has a value: " & aNullOfInt.HasValue)

        'Nevertheless the folowing construct returns True,
        'as if anObj had no reference!

        anObj = aNullOfInt
        Console.WriteLine("Is anObj Nothing? " & (anObj Is Nothing).ToString)
        Console.WriteLine()

        'And unboxing is possible as well!
        'There is no Null exception!
        aNullOfInt = DirectCast(anObj, Integer?)

        'And this works too?Of course!
        aNullOfInt = DirectCast(Nothing, Integer?)

        'We are boxing an Integer?
        aNullOfInt = 10
        '
        anObj = aNullOfInt
        'No Exception!
        Dim anInt As Integer = DirectCast(anObj, Integer)

        Console.WriteLine("Press key to exit!")
        Console.ReadKey()

        'This doesn't work even though Nullable
        'basically fulfills the constraint rules!
        'Dim anotherNullOfInt As Nullable(Of Integer?)
    End Sub

End Module
