Imports System.Collections.ObjectModel
Imports System.Xml.Serialization
Imports System.IO

Public Class Form1

    Private myAddress As New Addresses

    Protected Overrides Sub OnLoad(ByVal e As System.EventArgs)
        MyBase.OnLoad(e)
        myAddress.Add(New Address(2, "Lffelmann", "Klaus"))
        myAddress.Add(New Address(4, "Heckhuis", "Jrgen"))
        myAddress.Add(New Address(6, "Ardelean", "Adriana"))
        myAddress.Add(New Address(8, "Heckhuis", "Jrgen"))
        myAddress.Add(New Address(10, "Vielstedde", "Heidrun"))
    End Sub

    Private Sub btnPrintObjects_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnPrintObjects.Click
        For count As Integer = 0 To 4
            'Experiment with this code line. Complete and observe intellisense:
            Debug.Print(myAddress(
        Next
    End Sub

    Private Sub btnObjectsSerialize_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnObjectsSerialize.Click
        Dim writer As New XmlSerializer(GetType(Addresses))
        Dim file As New StreamWriter(My.Computer.FileSystem.SpecialDirectories.CurrentUserApplicationData & "\testdata_xml.xml")
        writer.Serialize(file, myAddress)
        file.Close()
    End Sub

    Private Sub btnObjectsDeserialize_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnObjectsDeserialize.Click
        Dim reader As New XmlSerializer(GetType(Addresses))
        Dim file As New StreamReader(My.Computer.FileSystem.SpecialDirectories.CurrentUserApplicationData & "\testdata_xml.xml")
        Dim fileData As Addresses
        fileData = CType(reader.Deserialize(file), Addresses)
    End Sub

End Class

Public Class Addresses
    'Change this integer type into type long to resolve the problem:
    Inherits System.Collections.ObjectModel.KeyedCollection(Of Integer, Address)

    'Here, for the return type, you have to change the type as well.
    Protected Overrides Function GetKeyForItem(ByVal item As Address) As Integer
        Return CInt(item.IDAddress)
    End Function
End Class

Public Class Address

    'This one we need for deserializing!
    Sub New()
        MyBase.new()
    End Sub

    Sub New(ByVal IDAdresse As Integer, ByVal LastName As String, ByVal FirstName As String)
        IDAdresse = IDAdresse
        LastName = LastName
        FirstName = FirstName
    End Sub

    Public Property IDAddress() As Integer
    Public Property LastName() As String
    Public Property FirstName() As String

End Class

