Imports System.XML.Serialization
Imports System.IO
Public Class Form1

    Private myAddress As New Addresses

    Protected Overrides Sub OnLoad(ByVal e As System.EventArgs)
        MyBase.OnLoad(e)
        myAddress.Add(New Address(2, "Lffelmann", "Klaus"))
        myAddress.Add(New Address(4, "Heckhuis", "Jrgen"))
        myAddress.Add(New Address(6, "Ardelean", "Adriana"))
        myAddress.Add(New Address(8, "Heckhuis", "Jrgen"))
        myAddress.Add(New Address(10, "Vielstedde", "Heidrun"))
    End Sub

    Private Sub btnPrintObjects_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnPrintObjects.Click
        For count As Integer = 0 To 4
            'Experiment with this code line. Complete and observe intellisense:
            'Debug.Print(myAddress(
        Next
    End Sub

    Private Sub btnObjectsSerialize_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnSerializeObjects.Click
        Dim writer As New XmlSerializer(GetType(Addresses))
        Dim file As New StreamWriter(My.Computer.FileSystem.SpecialDirectories.CurrentUserApplicationData & "\testdata_xml.xml")
        writer.Serialize(file, myAddress)
        file.Close()
    End Sub

    Private Sub btnObjectsDeserialize_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnDeserializeObjects.Click
        Dim reader As New XmlSerializer(GetType(Addresses))
        Dim file As New StreamReader(My.Computer.FileSystem.SpecialDirectories.CurrentUserApplicationData & "\testdata_xml.xml")
        Dim fileData As Addresses
        fileData = CType(reader.Deserialize(file), Addresses)
    End Sub

End Class

Public Class Addresses
    'This is an alternative way to solve the problemn with a structure called IntKey.
    Inherits System.Collections.ObjectModel.KeyedCollection(Of IntKey, Address)

    'Here, for the return type, we have to change the type as well.
    Protected Overrides Function GetKeyForItem(ByVal item As Address) As IntKey
        Return New IntKey(item.IDAddress)
    End Function
End Class

Public Class Address

    'This one we need for deserializing!
    Sub New()
        MyBase.new()
    End Sub

    Sub New(ByVal IDAdresse As Integer, ByVal LastName As String, ByVal FirstName As String)
        IDAdresse = IDAdresse
        LastName = LastName
        FirstName = FirstName
    End Sub

    Public Property IDAddress() As Integer
    Public Property LastName() As String
    Public Property FirstName() As String

End Class

<Serializable()> _
Public Class IntKey

    Private myKey As Integer

    'Wichtig fr die XML-Serialisierung: Parameterloser Konstruktor!
    Sub New()
        MyBase.new()
    End Sub

    Sub New(ByVal Key As Integer)
        myKey = Key
    End Sub

    Public ReadOnly Property Key() As Integer
        Get
            Return myKey
        End Get
    End Property
End Class