﻿Module Module1

    Const applicationName As String = "Typdemo"

    Sub Main()

        Dim intVar As New System.Int32()
        intVar = 5

        Dim intVar2 As Integer = 10

        Dim intvar3 As Integer = intVar2 + intVar
        Console.WriteLine(intvar3.ToString)

        'A contact is defined as a structure and can be
        'used immediately, without the New keyword—the memory
        'is allocated on the stack automatically.
        Dim aContact As ContactStructure
        aContact.FirstName = "Angela"
        aContact.LastName = "Merkel"
        aContact.ZIP = "09999"
        aContact.City = "Berlin"

        'The following statements demonstrate
        'the cloning of value type variables:
        'When assigning from value type to value type no references
        'are copied, but the contents are.
        Dim aDifferentContact As ContactStructure
        aDifferentContact = aContact

        'Changing the one "instance" has therfore
        'no impact on changing the second instance.
        aDifferentContact.LastName = "Schmidt"
        Console.WriteLine(aContact.LastName & ", " & aContact.FirstName)
        Console.ReadLine()

    End Sub

End Module

'This is the way to create a reference type, ...
Public Class Contact
    Public FirstName As String
    Public LastName As String
    Public ZIP As String
    Public City As String
End Class

'...and its Equivalent as a value type.
Public Structure ContactStructure
    Public FirstName As String
    Public LastName As String
    Public ZIP As String
    Public City As String
End Structure
