Module SortedListDemo

    Sub Main()
        Dim locRandomAddresses As ArrayList = Address.RandomAddresses(6)
        Dim locAddresses As New SortedList
        Console.WriteLine("Original sort:")

        For Each locAddress As Address In locRandomAddresses
            Console.WriteLine(locAddress)
            locAddresses.Add(locAddress.Matchcode, locAddress)
        Next

        'Access per index:
        Console.WriteLine()
        Console.WriteLine("Access per index:")
        For i As Integer = 0 To locAddresses.Count - 1
            Console.WriteLine(locAddresses.GetByIndex(i).ToString)
        Next

        Console.WriteLine()
        Console.WriteLine("Access per enumerator:")
        'Access per enumerator
        For Each locDE As DictionaryEntry In locAddresses
            Console.WriteLine(locDE.Value.ToString)
        Next

        Console.ReadLine()
    End Sub

    Sub SortedSetDemo()

        Dim t As New SortedSet(Of String) From {"Klaus", "Klaus", "Alpha", "Zeppelin"}

        For Each item In t
            Console.WriteLine(item)
        Next

        Console.WriteLine("Item count in the collection: " & t.Count)

        Console.ReadKey()

    End Sub

End Module
