Public Class frmMain

    Private Sub btnSerialisieren_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnSerialize.Click
        Dim locAdresse As New Address(txtFirstName.Text, _
                                      txtLastName.Text, _
                                      txtStreet.Text, _
                                      txtZipAndCity.Text)

        'Use an "impossible" file name, to make sure that no other
        'important file by the same name will override it.
        If optBinarySerializer.Checked Then
            'Use Binary Serializer
            Address.SerializeBinToFile(locAdresse, "C:\VisualBasic2010 ENG\serializedemo_bin_f4e3w21.bin")
        Else
            'Use Soap Serializer
            Address.SerializeSoapToFile(locAdresse, "C:\VisualBasic2010 ENG\serializedemo_soap_f4e3w21.txt")
        End If

        'Show Data Set Info
        txtErstelltAm.Text = locAdresse.DateCreated.ToString("dd.MM.yyyy HH:mm:ss")
        txtErstelltVon.Text = locAdresse.CreatedBy
    End Sub

    Private Sub btnDeserialisieren_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) _
                                            Handles btnDeserialize.Click
        Dim locAdresse As Address

        'Deserialize address object from file.
        If optBinarySerializer.Checked Then
            locAdresse = Address.SerializeBinFromFile("C:\VisualBasic2010 ENG\serializedemo_bin_f4e3w21.bin")
        Else
            locAdresse = Address.SerializeSoapFromFile("C:\VisualBasic2010 ENG\serializedemo_soap_f4e3w21.txt")
        End If

        'Show the data of the address object in the form.
        With locAdresse
            txtFirstName.Text = .FirstName
            txtLastName.Text = .LastName
            txtStreet.Text = .Street
            txtZipAndCity.Text = .ZipCity
            txtErstelltAm.Text = .DateCreated.ToString("dd.MM.yyyy HH:mm:ss")
            txtErstelltVon.Text = .CreatedBy
        End With
    End Sub

End Class
