﻿Module SimpleXml

    Sub Demo()

        ''''
        '''' Examples for new XML Structures in VB 2010
        ''''
        Dim xml As New XDocument
        xml.Add(New XElement("Fleet", _
                    New XElement("LicencePlate", "MS - VB 2010"), _
                    New XElement("Load", _
                                New XAttribute("Amount", "10 Tons"), _
                                "Salt"), _
                    New XElement("Manufacturer", "Mack") _
        ))

        xml.Element("Fleet").Add(New XElement("ModelYear", 1998))

        Console.WriteLine(xml)

        'Retrieve values with the Value property
        'Total "value":
        Console.WriteLine(xml.Element("Fleet").Value)

        'Only the ModelYear:
        Console.WriteLine(xml.Element("Fleet").Element("ModelYear").Value)
        Console.ReadKey()



        '' --------------------

        '''''
        ''''' Inline XML
        '''''

        Dim xElem As XElement = <Fleet>
                                    <LicencePlate>MS - VB 2010</LicencePlate>
                                    <Load Amount="10 Tons">Salt</Load>
                                    <Manufacturer>Mack</Manufacturer>
                                </Fleet>

        'xElem.Add(New XElement("ModelYear", 1998))
        'xElem.Add(<ModelYear>1998</ModelYear>)

        Dim myModelYear As Integer = 1993
        xElem.Add(<ModelYear><%= myModelYear %></ModelYear>)

        Dim xDoc As New XDocument(xElem)

        Console.WriteLine(xElem)
        Console.ReadKey()

    End Sub

End Module
