Imports System.Threading

Public Class frmMain

    'Member-Variable, so we can serially number the threads.
    'This is just for later examining purposes of the executing thread,
    'if it shows the results in the output window.
    Private myWorkerThreadNo As Integer = 1
    Private myThreadString As String

    Private Sub btnStartThread_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) _
                                        Handles btnStartThread.Click

        'This object encapsulates the actual thread
        Dim locThread As New Thread(
        Sub()
            'This is the worker thread responsible for
            'incrementing and the value output
            Dim strTemp As String
            For c As Integer = 0 To 50
                strTemp = Thread.CurrentThread.Name + ":: " + c.ToString
                'The thread waits for 1 second. If it cannot access the code
                'in this time it exits.
                If Not Monitor.TryEnter(Me, 1) Then
                    ThreadSafeTextWindow.TSWriteLine(
                    Thread.CurrentThread.Name +
                    " informs: Already in use!")
                    Thread.Sleep(50)
                Else
                    'Access was granted. Now the worker thread starts
                    'working
                    myThreadString = ""
                    For z As Integer = 0 To strTemp.Length - 1
                        myThreadString += strTemp.Substring(z, 1)
                        Thread.Sleep(5)
                    Next
                    ThreadSafeTextWindow.TSWriteLine(myThreadString)
                    Monitor.Exit(Me)
                End If
            Next
        End Sub)

        'Determine thread name
        locThread.Name = "Worker Thread: " + myWorkerThreadNo.ToString

        'Determine background thread:
        locThread.IsBackground = True

        'Start thread
        locThread.Start()

        'Counter to distinguish the threads by their names
        myWorkerThreadNo += 1
    End Sub

    Private Sub btnQuit_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnQuit.Click
        Me.Close()
    End Sub

End Class
