﻿Imports System.Threading
Imports System.Threading.Tasks

Class MainWindow

    Private Const MAXVALUE = 100
    Private Const SPINVALUE = 5000000

    'Actually, in this example are three versions of StartWorkingButton.Click.
    'Comment this method out, and uncomment the next methods to use them instead.
    'KEYBOARD SHORTCUT TIP: Select the range you want to comment out, and press Strg+k and then c.
    'Select the range you want to uncomment, and press Strg+k and then u.

    Private Sub StartWorkingButton_Click(ByVal sender As System.Object,
                                         ByVal e As System.Windows.RoutedEventArgs) _
                                        Handles StartWorkingButton.Click

        MainProgress.Maximum = MAXVALUE
        Me.Title = "WARNING: This sample is MEANT not to work. Please, refer to book and code!"

        Dim t As New Task(Sub()
                              For z = 0 To MAXVALUE
                                  Thread.SpinWait(SPINVALUE)

                                  'Delegate to UI thread to update the
                                  'ProgressBar. But it doesn't work
                                  'because Invoke requires a working
                                  'message loop that is blocked by
                                  't.Wait!

                                  Dispatcher.Invoke(Sub(insideValue As Integer)
                                                        MainProgress.Value = insideValue
                                                    End Sub, z)
                              Next
                          End Sub)

        'Start task
        t.Start()

        'This is going to block the UI-Thread
        t.Wait()

        'We will never see this...:-(
        MessageBox.Show("Task finished!")
    End Sub

    'Private Sub StartWorkingButton_Click(ByVal sender As System.Object,
    '                                 ByVal e As System.Windows.RoutedEventArgs) _
    '                                Handles StartWorkingButton.Click

    '    MainProgress.Maximum = MAXVALUE

    '    Dim t2 As New Task(
    '        Sub()
    '            Dim t As New Task(Sub()
    '                                  For z = 0 To MAXVALUE
    '                                      Thread.SpinWait(SPINVALUE)
    '                                      'Delegate to UI thread to update
    '                                      'the ProgressBar.
    '                                      Dispatcher.Invoke(Sub(insideValue As Integer)
    '                                                            MainProgress.Value = insideValue
    '                                                        End Sub, z)
    '                                  Next
    '                              End Sub)

    '            'Start Worker task
    '            t.Start()

    '            'The UI thread will not be frozen because it runs in its own task.
    '            t.Wait()

    '            'This is how it works:
    '            Dispatcher.Invoke(Sub()
    '                                  MessageBox.Show("Task abgeschlossen!")
    '                              End Sub)

    '        End Sub)

    '    'Start parent task.
    '    t2.Start()
    'End Sub

    Private myCtSource As CancellationTokenSource
    Private myCToken As CancellationToken

    'Private Sub StartWorkingButton_Click(ByVal sender As System.Object,
    '                             ByVal e As System.Windows.RoutedEventArgs) _
    '                            Handles StartWorkingButton.Click

    '    If StartWorkingButton.Content.ToString = "Stop!" Then
    '        If myCtSource IsNot Nothing Then
    '            myCtSource.Cancel()
    '            Exit Sub
    '        End If
    '    End If

    '    StartWorkingButton.Content = "Stop!"

    '    MainProgress.Maximum = MAXVALUE

    '    myCtSource = New CancellationTokenSource()
    '    myCToken = myCtSource.Token

    '    Dim sw = Stopwatch.StartNew

    '    Dim tMain As New Task(
    '                 Sub()
    '                     Dim t As New Task(
    '                     Sub()
    '                         For z = 0 To MAXVALUE
    '                             Thread.SpinWait(SPINVALUE)

    '                             'Delegate to UI thread to refresh
    '                             'the progress bar.
    '                             Dispatcher.Invoke(Sub(insideValue As Integer)
    '                                                   MainProgress.Value = insideValue
    '                                               End Sub, z)

    '                             If myCToken.IsCancellationRequested Then

    '                                 Debug.Print("Throwing Cancellation Requested Exception:" &
    '                                                                                  sw.ElapsedMilliseconds.ToString)
    '                                 myCToken.ThrowIfCancellationRequested()
    '                             End If

    '                         Next
    '                     End Sub, myCToken)

    '                     Dim t2 As New Task(
    '                                Sub()
    '                                    For z = 0 To MAXVALUE \ 10
    '                                        Thread.SpinWait(SPINVALUE * 10)
    '                                        'Delegate to UI thread to refresh
    '                                        'the progress bar.
    '                                        Dispatcher.Invoke(
    '                                        Sub(insideValue As Integer)
    '                                            Label1.Content = "Task 2 is also active:" &
    '                                            insideValue.ToString
    '                                        End Sub, z)

    '                                        If myCToken.IsCancellationRequested Then
    '                                            Debug.Print("Throwing Cancellation Requested Exception:" & sw.ElapsedMilliseconds.ToString)
    '                                            myCToken.ThrowIfCancellationRequested()
    '                                            'Throw New OperationCanceledException("Thrown manually")
    '                                        End If
    '                                    Next
    '                                End Sub, myCToken)

    '                     'Start Worker tasks
    '                     t.Start()
    '                     t2.Start()
    '                     Try
    '                         'In this version the exception occurs when the
    '                         'first task is cancelled.
    '                         Task.WaitAll({t, t2}, myCToken)

    '                         'In this version the AggregateException occurs
    '                         'after all tasks were cancelled.
    '                         'Task.WaitAll({t, t2})
    '                         'This already intercepts the first cancellation.
    '                     Catch ex As OperationCanceledException
    '                         Debug.Print("Caught Exception: " & sw.ElapsedMilliseconds.ToString)
    '                         Dispatcher.Invoke(Sub()
    '                                               MessageBox.Show("Task cancelled!")
    '                                           End Sub)

    '                         'Version waiting without CancellationToken.
    '                         'Catch ex As AggregateException
    '                         ' Dispatcher.Invoke(Sub()
    '                         ' MessageBox.Show("All tasks cancelled!")
    '                         ' End Sub)
    '                     End Try

    '                     'If the previous tasks were cancelled this task doesn't start
    '                     'because this is also controlled by myCToken.
    '                     Dim t3 = Task.Factory.StartNew(
    '                             Sub()
    '                                 Dispatcher.Invoke(
    '                                     Sub()
    '                                         MessageBox.Show("Task 3 Start!")
    '                                     End Sub)
    '                             End Sub, myCToken)

    '                     Dispatcher.Invoke(
    '                         Sub()
    '                             If myCToken.IsCancellationRequested Then
    '                                 Label1.Content = "Cancelled."
    '                                 StartWorkingButton.Content = "Start!"
    '                             Else
    '                                 Label1.Content = "Done."
    '                                 StartWorkingButton.Content = "Start!"
    '                                 MessageBox.Show("Task finished!")
    '                             End If
    '                         End Sub)

    '                     Debug.Print("Status Task 1:" & t.Status.ToString)
    '                     Debug.Print("Status Task 2:" & t2.Status.ToString)
    '                     Debug.Print("Status Task 3:" & t3.Status.ToString)

    '                 End Sub, myCToken)

    '    'Start parent task
    '    tMain.Start()
    'End Sub
End Class
